//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%36894B22C6D8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%36894B22C6D8.cm

//## begin module%36894B22C6D8.cp preserve=no
//## end module%36894B22C6D8.cp

//## Module: DataSet%36894B22C6D8; Package body
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/DataSet.cxx

//## begin module%36894B22C6D8.additionalIncludes preserve=no
//## end module%36894B22C6D8.additionalIncludes

//## begin module%36894B22C6D8.includes preserve=yes
#include <XSModel/GlobalContainer/TrashPtr.h>
#include <XSModel/GlobalContainer/TrashAdapter.h>
//## end module%36894B22C6D8.includes

// DataContainer
#include <XSModel/GlobalContainer/DataContainer.h>
// DataSetBase
#include <XSModel/Data/DataSetBase.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// DataSetTypes
#include <XSModel/GlobalContainer/DataSetTypes.h>
// DataSet
#include <XSModel/Data/DataSet.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>


//## begin module%36894B22C6D8.declarations preserve=no
//## end module%36894B22C6D8.declarations

//## begin module%36894B22C6D8.additionalDeclarations preserve=yes
#include <XSModel/DataFactory/DataFactory.h>
#include <XSModel/Data/BackCorr/Background.h>
#include <XSModel/Data/DataUtility.h>
#include <XSModel/GlobalContainer/ResponseContainer.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Numerics/RandomGenerator.h>
#include "XSstreams.h"
#include "XSContainer.h"
#include <cassert>
#include <fstream>
#include <iomanip>
#include <unistd.h>
#include <limits.h>

using namespace XSContainer;
//## end module%36894B22C6D8.additionalDeclarations


// Class DataSet::AbortDataLoop 

DataSet::AbortDataLoop::AbortDataLoop (const string& msg)
  //## begin DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.hasinit preserve=yes
  : YellowAlert(msg)
  //## end DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.hasinit
  //## begin DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.initialization preserve=yes
  //## end DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.initialization
{
  //## begin DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.body preserve=yes
  //## end DataSet::AbortDataLoop::AbortDataLoop%3A5CCAEE0255.body
}


// Class DataSet::ResponseIsNeeded 

DataSet::ResponseIsNeeded::ResponseIsNeeded (const string& msg)
  //## begin DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.hasinit preserve=yes
  : YellowAlert("Valid response file is needed\n")
  //## end DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.hasinit
  //## begin DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.initialization preserve=yes
  //## end DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.initialization
{
  //## begin DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.body preserve=yes
   tcerr << msg << std::endl;
  //## end DataSet::ResponseIsNeeded::ResponseIsNeeded%3E9476B90159.body
}


// Class DataSet 

//## begin DataSet::count%39E35E1502F6.attr preserve=no  protected: static int {U} 
int DataSet::s_count;
//## end DataSet::count%39E35E1502F6.attr

//## begin DataSet::useFakeCountingStat%3EDCAA3702D7.attr preserve=no  public: static bool {U} 
bool DataSet::s_useFakeCountingStat;
//## end DataSet::useFakeCountingStat%3EDCAA3702D7.attr

//## begin DataSet::xspecVersion%3EFC609F030B.attr preserve=no  public: static string {U} 
string DataSet::s_xspecVersion;
//## end DataSet::xspecVersion%3EFC609F030B.attr

//## begin DataSet::STD_FIRST_CHAN%41C9EFE0003E.attr preserve=no  public: static const size_t {U} 1
const size_t DataSet::s_STD_FIRST_CHAN = 1;
//## end DataSet::STD_FIRST_CHAN%41C9EFE0003E.attr

DataSet::DataSet()
  //## begin DataSet::DataSet%362CB3E90259_const.hasinit preserve=yes
  : m_dataSetBase(0)
  //## end DataSet::DataSet%362CB3E90259_const.hasinit
  //## begin DataSet::DataSet%362CB3E90259_const.initialization preserve=yes
  //## end DataSet::DataSet%362CB3E90259_const.initialization
{
  //## begin DataSet::DataSet%362CB3E90259_const.body preserve=yes
  ++s_count;
  //## end DataSet::DataSet%362CB3E90259_const.body
}

DataSet::DataSet(const DataSet &right)
  //## begin DataSet::DataSet%362CB3E90259_copy.hasinit preserve=yes
      : m_dataSetBase(0)
  //## end DataSet::DataSet%362CB3E90259_copy.hasinit
  //## begin DataSet::DataSet%362CB3E90259_copy.initialization preserve=yes
  //## end DataSet::DataSet%362CB3E90259_copy.initialization
{
  //## begin DataSet::DataSet%362CB3E90259_copy.body preserve=yes
  if (right.m_dataSetBase) 
  {
        m_dataSetBase = new DataSetBase(*right.m_dataSetBase);
        m_dataSetBase->index(++s_count);
  }
  //## end DataSet::DataSet%362CB3E90259_copy.body
}


DataSet::~DataSet()
{
  //## begin DataSet::~DataSet%362CB3E90259_dest.body preserve=yes
  // calls DataSetBase's dtor which calls DataSetBase::destroy() nothrow().
  destroy();
  //## end DataSet::~DataSet%362CB3E90259_dest.body
}


DataSet & DataSet::operator=(const DataSet &right)
{
  //## begin DataSet::operator=%362CB3E90259_assign.body preserve=yes
  if (this != &right) copy(right);
  return *this;
  //## end DataSet::operator=%362CB3E90259_assign.body
}



//## Other Operations (implementation)
void DataSet::plot (const string& args)
{
  //## begin DataSet::plot%3860E0D78530.body preserve=yes
  //## end DataSet::plot%3860E0D78530.body
}

void DataSet::Swap (DataSet& right)
{
  //## begin DataSet::Swap%39E3870302E7.body preserve=yes
  std::swap(m_dataSetBase,right.m_dataSetBase);
  //## end DataSet::Swap%39E3870302E7.body
}

const std::vector<int>& DataSet::groupingInfo (size_t row) const
{
  //## begin DataSet::groupingInfo%39F84FF702CD.body preserve=yes

  return sourceData(row)->groupingInfo();      
  //## end DataSet::groupingInfo%39F84FF702CD.body
}

const std::vector<int>& DataSet::qualityInfo (size_t row) const
{
  //## begin DataSet::qualityInfo%39F8503A0166.body preserve=yes
  return sourceData(row)->qualityInfo();      
  //## end DataSet::qualityInfo%39F8503A0166.body
}

size_t DataSet::channels (size_t row) const
{
  //## begin DataSet::channels%39F87CED027F.body preserve=yes
  return sourceData(row)->channels();      
  //## end DataSet::channels%39F87CED027F.body
}

const string& DataSet::dataName () const
{
  //## begin DataSet::dataName%39F88AF0007F.body preserve=yes
  return m_dataSetBase->dataName();
  //## end DataSet::dataName%39F88AF0007F.body
}

SpectralData*& DataSet::sourceData (size_t row)
{
  //## begin DataSet::sourceData%3A2BDB0C0394.body preserve=yes
  return m_dataSetBase->multiSpectralData(row);
  //## end DataSet::sourceData%3A2BDB0C0394.body
}

void DataSet::setData (size_t spectrumNumber, size_t row)
{
  //## begin DataSet::setData%3A22A6A902E7.body preserve=yes
  setArrays(row);
                  
  setDescription(spectrumNumber,row); 
  
  groupArrays(row);      
  
  setResponse(spectrumNumber,row);       

  setAncillaryData(row);
  
  scaleArrays(row);  
  
  SpectralData& spectrum = *sourceData(row);
  
  // Deliberately setting spectrum's isPoisson flag PRIOR to
  // to any variance modifications due to weighting.  The
  // flag refers to the state as originally read in from the file.
  spectrum.checkForPoisson(0);
  
  DataUtility::statWeight()(spectrum,spectrum.areaScale()*spectrum.exposureTime());
  
  computeTotals(row);
  
  //## end DataSet::setData%3A22A6A902E7.body
}

void DataSet::setResponse (size_t spectrumNumber, size_t row)
{
  //## begin DataSet::setResponse%3A35417C03DC.body preserve=yes
  //## end DataSet::setResponse%3A35417C03DC.body
}

void DataSet::scaleArrays (size_t row)
{
  //## begin DataSet::scaleArrays%3A2BAA5702CE.body preserve=yes
  SpectralData* data = sourceData(row);
  
  const  Real ONE = 1.;  
  
  RealArray dataNorm = ONE/data->areaScale();
  
  if ( isCounts() ) dataNorm   /= data->exposureTime();
  
  RealArray var(data->rawVariance());
  RealArray spectrum(data->spectrum());
  
  size_t n = data->channels();
  var *= dataNorm*dataNorm;
  spectrum *= dataNorm;
  
  data->setRawVariance(var);
  data->setSpectrum(spectrum);
  
  // store the variance immediately after grouping for
  // use in resetting variance after different weighting schemes are applied.
 
  data->debugPrint(static_cast<XSstream&>(tcout),"Spectrum");
  //## end DataSet::scaleArrays%3A2BAA5702CE.body
}

void DataSet::ignoreBadChannels ()
{
  //## begin DataSet::ignoreBadChannels%3BBCD7B801D7.body preserve=yes
  if (!isMultiple())
  {
          m_dataSetBase->spectralData()->setBadChannels();
  }
  else
  {
          SpectralDataMapIt ig(m_dataSetBase->multiSpectralData().begin());
          SpectralDataMapIt igEnd(m_dataSetBase->multiSpectralData().end());
          
          while ( ig != igEnd )
          {
                (*ig).second->setBadChannels();
                ++ig;       
          }
  }
  //## end DataSet::ignoreBadChannels%3BBCD7B801D7.body
}

bool DataSet::isCounts () const
{
  //## begin DataSet::isCounts%3A366F3100E0.body preserve=yes
  //## end DataSet::isCounts%3A366F3100E0.body

  return true;
}

void DataSet::report (size_t row) const
{
  //## begin DataSet::report%3A2E71320004.body preserve=yes
   const SpectralData* spec = sourceData(row);
   spec->report();
  //## end DataSet::report%3A2E71320004.body
}

void DataSet::destroy () throw ()
{
  //## begin DataSet::destroy%3A36436C027B.body preserve=yes
  delete m_dataSetBase;
  //## end DataSet::destroy%3A36436C027B.body
}

void DataSet::reportAll ()
{
  //## begin DataSet::reportAll%3A378D1000FC.body preserve=yes
  if (dataSetBase()->spectralData()) report(0);
  else
  {
          const SpectralDataMap& mSD = dataSetBase()->multiSpectralData();
          SpectralDataMapConstIt endList = mSD.end();
          for (SpectralDataMapConstIt i = mSD.begin(); i != endList; ++i)
          {
                  report(i->first);
          }                

  }
  tcout << std::flush;
  //## end DataSet::reportAll%3A378D1000FC.body
}

void DataSet::computeTotals (size_t row)
{
  //## begin DataSet::computeTotals%3A378ECB022B.body preserve=yes
  SpectralData* data = sourceData(row);
  data->computeTotals();      
  //## end DataSet::computeTotals%3A378ECB022B.body
}

const SpectralData* DataSet::sourceData (size_t row) const
{
  //## begin DataSet::sourceData%3A3794B3018C.body preserve=yes
  return m_dataSetBase->multiSpectralData(row);
  //## end DataSet::sourceData%3A3794B3018C.body
}

bool DataSet::isMultiple () const
{
  //## begin DataSet::isMultiple%3A394B560027.body preserve=yes
  if (!m_dataSetBase)
  {
     return false;
  }
  return !m_dataSetBase->multiSpectralData().empty();
  //## end DataSet::isMultiple%3A394B560027.body
}

int DataSet::numSpectra () const
{
  //## begin DataSet::numSpectra%3A3A652E018A.body preserve=yes
  if (isMultiple()) return m_dataSetBase->multiSpectralData().size();
  else if (spectralData()) return 1; 
  else return 0;     
  //## end DataSet::numSpectra%3A3A652E018A.body
}

void DataSet::legalChannelBounds (int& startChan, int& endChan) const
{
  //## begin DataSet::legalChannelBounds%3A48DE0100AE.body preserve=yes
  startChan = m_dataSetBase->legalStartChan();
  endChan = m_dataSetBase->legalEndChan();
  //## end DataSet::legalChannelBounds%3A48DE0100AE.body
}

bool DataSet::groupingSet (size_t row)
{
  //## begin DataSet::groupingSet%3A59E2F103B3.body preserve=yes
  //## end DataSet::groupingSet%3A59E2F103B3.body

  return !groupingInfo(row).empty();
}

bool DataSet::qualitySet (size_t row)
{
  //## begin DataSet::qualitySet%3A59E3E3015C.body preserve=yes
  //## end DataSet::qualitySet%3A59E3E3015C.body

  return !qualityInfo(row).empty();
}

size_t DataSet::dataGroup () const
{
  //## begin DataSet::dataGroup%3AAE558401A4.body preserve=yes
  //## end DataSet::dataGroup%3AAE558401A4.body

  return m_dataSetBase->dataGroup();
}

void DataSet::dataGroup (size_t group)
{
  //## begin DataSet::dataGroup%3AAE55AA0248.body preserve=yes
  //## end DataSet::dataGroup%3AAE55AA0248.body

  m_dataSetBase->dataGroup(group);
}

size_t DataSet::index () const
{
  //## begin DataSet::index%3BB2093F03CA.body preserve=yes
  //## end DataSet::index%3BB2093F03CA.body

  return m_dataSetBase->index();
}

int DataSet::removeNumberedSpectrum (size_t index, bool remove)
{
  //## begin DataSet::removeNumberedSpectrum%3C1FD05201FC.body preserve=yes
  static const string REMOVED(" removed ");
  static const string REPLACED(" replaced ");
  int status = 0;
  if ( isMultiple() )
  {
        
        SpectralDataMap& sdm = m_dataSetBase->multiSpectralData();
        SpectralDataMapIt sdmi   = sdm.begin(); 
        SpectralDataMapIt sdmEnd = sdm.end();
        while (sdmi != sdmEnd)
        {
                if (index == sdmi->second->spectrumNumber())
                {
		    SpectralData* s = sdmi->second;

		    //a little different than the classic memento pattern...
		    //in this case, DataSet is requesting the memento,
		    //however, SpectralData will also hold onto it. With the 
		    //new undo scheme, the DataSet could be deleted, and the 
		    //SpectralData could still be floating around.
		    s->CreateMemento();

		    responses->removeByToken(s->detector());
		    datasets->moveToTrash(new TrashAdapter<SpectralData*>(s));

		    sdm.erase(sdmi);

		    status = sdm.empty() ? -1 : 1;
		    tcout << "\nSpectrum #: " << index ;
		    tcout << (remove ?  REMOVED :  REPLACED) ;
		    tcout << std::endl;
		    break;
                }       
                else ++sdmi;
        }         
  }
  else
  {
          SpectralData* spectrum = m_dataSetBase->spectralData();
          if (index == spectrum->spectrumNumber()) 
          {
	      spectrum->CreateMemento();

	      responses->removeByToken(spectrum->detector());
	      datasets->moveToTrash(new TrashAdapter<SpectralData*>(spectrum));

	      //this is so spectralData isn't deleted if/when the 
	      //dataset is destroyed
	      m_dataSetBase->spectralData(0);

	      tcout << "\nSpectrum #: " << index ;
	      tcout << (remove ?  REMOVED :  REPLACED) ;
	      tcout << std::endl;                          
	      status = -1;
          }
  }
  return status;
  //## end DataSet::removeNumberedSpectrum%3C1FD05201FC.body
}

void DataSet::setChannels (bool value, IntegerArray& channelRange)
{
  //## begin DataSet::setChannels%3BBE174E0003.body preserve=yes
        
        
  // I believe the primary purpose of this is to support "notice all"             
  if (!isMultiple())
  {
          m_dataSetBase->spectralData()->setChannels(value,channelRange);
  }
  else
  {
          SpectralDataMapIt ig(m_dataSetBase->multiSpectralData().begin());
          SpectralDataMapIt igEnd(m_dataSetBase->multiSpectralData().end());
          
          while ( ig != igEnd )
          {
                (*ig).second->setChannels(value,channelRange);
                ++ig;       
          }
  }
        
  //## end DataSet::setChannels%3BBE174E0003.body
}

void DataSet::setChannels (bool value, std::pair<Real,Real>& realRange)
{
  //## begin DataSet::setChannels%3BD95A850132.body preserve=yes
  using namespace XSContainer; 
  // ... this one might not be needed, but could support a future command
  // syntax whose intent is "ignore/notice all files in a given dataset
  // with energy/wavelength equal to realRange".
        
  if (!isMultiple())
  {
          m_dataSetBase->spectralData()->setChannels(value,realRange);
  }
  else
  {
          SpectralDataMapIt  ig(m_dataSetBase->multiSpectralData().begin());
          SpectralDataMapIt  igEnd(m_dataSetBase->multiSpectralData().end());
          
          while ( ig != igEnd )
          {
                (*ig).second->setChannels(value,realRange);
                ++ig;       
          }
  }
  //## end DataSet::setChannels%3BD95A850132.body
}

SpectralData* DataSet::spectralData () const
{
  //## begin DataSet::spectralData%3C1FCBFA01C3.body preserve=yes
  return m_dataSetBase->spectralData();
  //## end DataSet::spectralData%3C1FCBFA01C3.body
}

const std::map<size_t,SpectralData*>& DataSet::multiSpectralData () const
{
  //## begin DataSet::multiSpectralData%3C1FCC3802A2.body preserve=yes
  return m_dataSetBase->multiSpectralData();
  //## end DataSet::multiSpectralData%3C1FCC3802A2.body
}

void DataSet::groupArrays (size_t row)
{
  //## begin DataSet::groupArrays%3C51AB9001AE.body preserve=yes
  //## end DataSet::groupArrays%3C51AB9001AE.body
}

int DataSet::origNumSources () const
{
  //## begin DataSet::origNumSources%3C76A99301B8.body preserve=yes
   return m_dataSetBase->origNumSources();
  //## end DataSet::origNumSources%3C76A99301B8.body
}

void DataSet::origNumSources (int value)
{
  //## begin DataSet::origNumSources%3C76A9BA011E.body preserve=yes
   m_dataSetBase->origNumSources(value);
  //## end DataSet::origNumSources%3C76A9BA011E.body
}

bool DataSet::setResponse (SpectralData* sourceSpectrum, size_t spectrumNumber, size_t sourceNum, const string& responseName, const string& arfName)
{
  //## begin DataSet::setResponse%3CD69E3800CA.body preserve=yes
  return false;
  //## end DataSet::setResponse%3CD69E3800CA.body
}

bool DataSet::setBackgroundData (size_t row, int bckRow)
{
  //## begin DataSet::setBackgroundData%3D1CACBC0231.body preserve=yes
  return false;
  //## end DataSet::setBackgroundData%3D1CACBC0231.body
}

bool DataSet::setCorrectionData (size_t row, int corRow)
{
  //## begin DataSet::setCorrectionData%3D1CAD1300A3.body preserve=yes
  return false;
  //## end DataSet::setCorrectionData%3D1CAD1300A3.body
}

bool DataSet::resetAllDetectors ()
{
  //## begin DataSet::resetAllDetectors%3E7247E1018F.body preserve=yes
  bool isChanged = false;
  
  if (!isMultiple())
  {
          isChanged = m_dataSetBase->spectralData()->removeAllDummies();
  }
  else
  {
          SpectralDataMapIt ig(m_dataSetBase->multiSpectralData().begin());
          SpectralDataMapIt igEnd(m_dataSetBase->multiSpectralData().end());
          
          while ( ig != igEnd )
          {
                if((*ig).second->removeAllDummies())
		{
		   isChanged = true;
		}
                ++ig;       
          }
  }
        
  return isChanged;
  //## end DataSet::resetAllDetectors%3E7247E1018F.body
}

void DataSet::nullBackPointers (const IntegerArray& rows)
{
  //## begin DataSet::nullBackPointers%3EA02D9F02B6.body preserve=yes
  if (!isMultiple())
  {
     m_dataSetBase->spectralData()->background(static_cast<Background*>(0));
  }
  else if (!rows.size())
  {
     SpectralDataMapIt id(m_dataSetBase->multiSpectralData().begin());
     SpectralDataMapIt idEnd(m_dataSetBase->multiSpectralData().end());
     while (id != idEnd)
     {
	id->second->background(static_cast<Background*>(0));
	++id;
     }
  }
  else
  {
     for (int i=0; i<rows.size(); ++i)
     {
        SpectralDataMapIt id = m_dataSetBase->multiSpectralData().find(rows[i]);
	if (id == m_dataSetBase->multiSpectralData().end())
	{
	   throw RedAlert("Accessing non-existant spectrum in DataSet::nullBackPointers\n");
	}
	id->second->background(static_cast<Background*>(0));	
     }
  }
  //## end DataSet::nullBackPointers%3EA02D9F02B6.body
}

bool DataSet::specNumOrder (IntegerArray& rows) const
{
  //## begin DataSet::specNumOrder%3EA954220206.body preserve=yes
  
  // Basically, this function allows external objects a way to access
  // the multiple spectra in order of spectrum number, rather than by
  // row number which is how they are originally stored in the 
  // multiSpectralDataMap.  It does not modify the multiSpectralDataMap,
  // but instead fills an array of the row numbers in the order they 
  // should be called to go from lowest spectrum number to highest.
  
  // Return 'true' if spectrum numbers in multiDataSet are in sequential
  // order, or if this is only a single spectrum set.
  bool flag = true;
  rows.clear();
  if (isMultiple())
  {
     SpectralDataMap specNumsData;
     SpectralDataMapConstIt sdIt = m_dataSetBase->multiSpectralData().begin();
     SpectralDataMapConstIt sdEnd = m_dataSetBase->multiSpectralData().end();
     while (sdIt != sdEnd)
     {
        SpectralDataMap::value_type tmp(sdIt->second->spectrumNumber(),
					sdIt->second);
        specNumsData.insert(tmp);
        ++sdIt;
     }
     
     SpectralDataMapConstIt sdsIt = specNumsData.begin();
     SpectralDataMapConstIt sdsEnd = specNumsData.end();
     size_t prevNum;
     if (sdsIt != sdsEnd)
     {
        prevNum = sdsIt->first;
	rows.push_back(sdsIt->second->rowNumber());
        ++sdsIt;
     }
     while (sdsIt != sdsEnd)
     {
        if (sdsIt->first != (prevNum+1))
	{
	   flag = false;
	}
	rows.push_back(sdsIt->second->rowNumber());
	prevNum = sdsIt->first;
        ++sdsIt;
     }
  }
  else
  {  // type 1
     rows.push_back(0);
  }
  return flag;
  //## end DataSet::specNumOrder%3EA954220206.body
}

void DataSet::generateFake ()
{
  //## begin DataSet::generateFake%3ED4D8AE02B2.body preserve=yes
  size_t start, stop;
  start = isMultiple() ? 1 : 0;
  stop = isMultiple() ? multiSpectralData().size()+1 : 1;
  for (size_t i=start; i<stop; ++i)
  {
     // SECTION 1: create fake spectrum
     SpectralData* sd = sourceData(i);
     // Spectrum should already contain M*R by this point.
     RealArray& fake = sd->spectrum();
     RealArray var = sd->rawVariance();
     const size_t nChans = fake.size(); 
     const RealArray atime = sd->exposureTime()*sd->areaScale();


     // This should be Poisson or Gaussian depending on the statistics in the 
     // pre-existing dataset otherwise Poisson
     bool isPoisson = sd->isPoisson();

     // Add correction if any:
     if (sd->correction())
     {
        fake += sd->correctionScale()*sd->correction()->data()->spectrum();
     }

     // First do the source - if randomize option is set then use either
     // Poisson or Normal statistics depending on what it set in the current
     // data file. If there is no current data file then assume Poisson.

     if (s_useFakeCountingStat)
     {
	if (isPoisson)
	{
              fake *= atime;
              Numerics::PoissonRand(fake);
              fake /= atime;
        } 
        else
        {
              RealArray gaussNum(0.0,nChans);
              Numerics::GaussRand(gaussNum);
              fake += gaussNum*sqrt(var);
        }
     }

     // if Poisson statistics then set the variance appropriately
     // if Gaussian statistics then keep the values originally set

     if (isPoisson)
     {
	var = fake/atime;
     }

     // now add in the background if requested	   

     bool isBackPoisson = false;
     if (sd->background())
     {
        SpectralData* backSpec = sd->getBackground()->data();
        RealArray fakeBackground = backSpec->spectrum();
        RealArray varBackground = backSpec->rawVariance();
        // This is sort of a hack.  If non-standard weighting
        // was in use at the time fake background was created,
        // that would have carried over into its variance array.
        // We don't want that, so...
        backSpec->setVariance(varBackground);

        isBackPoisson = backSpec->isPoisson();
        if (s_useFakeCountingStat)
        {
           if (isBackPoisson)
           {
              fakeBackground *= atime;
              Numerics::PoissonRand(fakeBackground);
              fakeBackground /= atime;
           }
           else
           {
              RealArray gaussNum(0.0,nChans);
              Numerics::GaussRand(gaussNum);
              fakeBackground += gaussNum*sqrt(varBackground);
           }
        }

        // if Poisson statistics then set the variance appropriately
        // if Gaussian statistics then keep the values originally set

        if (isBackPoisson)
        {
	   varBackground = fakeBackground/atime;
        }


       // sum in the background rate (and variance for Poisson
       // spectra only).

        fake += fakeBackground;
        if (isPoisson)
           var += varBackground;

     }

     // set the variance

     sd->setRawVariance(var);
     sd->setVariance(var);

     
     // SECTION 2:
     // Do the same to background, if it exists.
     if (sd->background())
     {
        // NOTE: The fake background spectrum at this stage includes 
        // the ratio multiplier SpecBSCALE/BckBSCALE, and bkVar
        // contains the ratio squared.  This must be accounted for
        // when converting to counts for Poisson randomization,
        // and will be removed during the write to file.
        SpectralData* bsd = sd->getBackground()->data();
        RealArray& fakeBackground = bsd->spectrum();
        if (s_useFakeCountingStat)
        {
           const RealArray batime = bsd->exposureTime()*bsd->areaScale();
           RealArray atimeRatio = batime*bsd->backgroundScale()
                                   /sd->backgroundScale();
           fakeBackground *= atimeRatio;
           if (isBackPoisson)
           {
              Numerics::PoissonRand(fakeBackground);
              fakeBackground /= atimeRatio;
              RealArray var(fakeBackground/atimeRatio);
              bsd->setRawVariance(var);
              bsd->setVariance(var);
           }
           else
           {
              // In here, rawVariance is same as variance due
              // to the hack earlier in this function.
              RealArray bkVar(bsd->variance());
              bkVar *= (atimeRatio*atimeRatio);
              RealArray gaussNum(0.0,nChans);
              Numerics::GaussRand(gaussNum);
              fakeBackground += gaussNum*sqrt(bkVar);
              fakeBackground /= atimeRatio;
           } // end if !isBackPoisson
        } // end if useFakeCountingStat
     } // end if background
     sd->checkForPoisson(0);
     
     // Now apply any weighting to the variances.  Perhaps this block 
     // could be placed in a separate function at some point, in
     // SpectralData.  This same code exists in xsWeight.
     if (Background* bkg = sd->getBackground())
     {
        RealArray bkgNorm = bkg->data()->areaScale()*bkg->data()->exposureTime();
        bkgNorm *= bkg->data()->backgroundScale()/sd->backgroundScale();
        DataUtility::statWeight()(*(bkg->data()), bkgNorm);
     }
     DataUtility::statWeight()(*sd, atime);
     
     sd->computeTotals();
  }
  //## end DataSet::generateFake%3ED4D8AE02B2.body
}

const string& DataSet::outputFileName () const
{
  //## begin DataSet::outputFileName%3EDCC2DC0298.body preserve=yes
   return m_dataSetBase->outputFileName();
  //## end DataSet::outputFileName%3EDCC2DC0298.body
}

void DataSet::outputFileName (const string& fileName)
{
  //## begin DataSet::outputFileName%3EDCC311014C.body preserve=yes
   m_dataSetBase->outputFileName(fileName);
  //## end DataSet::outputFileName%3EDCC311014C.body
}

const string& DataSet::outputBckFileName () const
{
  //## begin DataSet::outputBckFileName%3EDCEB230106.body preserve=yes
   return m_dataSetBase->outputBckFileName();
  //## end DataSet::outputBckFileName%3EDCEB230106.body
}

void DataSet::outputBckFileName (const string& fileName)
{
  //## begin DataSet::outputBckFileName%3EDCEB6502CF.body preserve=yes
   m_dataSetBase->outputBckFileName(fileName);
  //## end DataSet::outputBckFileName%3EDCEB6502CF.body
}

size_t DataSet::getMaxChannels () const
{
  //## begin DataSet::getMaxChannels%3EDD15BD0080.body preserve=yes
  size_t maxChans = 0;
  if (!isMultiple())
  {
     maxChans = spectralData()->endChan() - spectralData()->startChan() + 1;
  }
  else
  {
     SpectralDataMapConstIt spec = m_dataSetBase->multiSpectralData().begin();
     SpectralDataMapConstIt end = m_dataSetBase->multiSpectralData().end();
     while (spec != end)
     {
        size_t currChans = spec->second->endChan() - spec->second->startChan() + 1;
        maxChans = (currChans > maxChans) ? currChans : maxChans;
        ++spec;
     }
  }
  return maxChans;
  //## end DataSet::getMaxChannels%3EDD15BD0080.body
}

void DataSet::setModelNamesForFake (const string& name, size_t index)
{
  //## begin DataSet::setModelNamesForFake%3EFB64F00133.body preserve=yes
  m_dataSetBase->modelNamesForFake(index, name);
  //## end DataSet::setModelNamesForFake%3EFB64F00133.body
}

void DataSet::setModelNamesForFake (const StringArray& names)
{
  //## begin DataSet::setModelNamesForFake%3EFC854A0025.body preserve=yes
  m_dataSetBase->setModelNamesForFake(names);
  //## end DataSet::setModelNamesForFake%3EFC854A0025.body
}

bool DataSet::anyQuality () const
{
  //## begin DataSet::anyQuality%3F74811501CE.body preserve=yes
  if (isMultiple())
  {
     SpectralDataMap::const_iterator iSp = m_dataSetBase->multiSpectralData().begin();
     SpectralDataMap::const_iterator iEnd = m_dataSetBase->multiSpectralData().end();
     while (iSp != iEnd)
     {
        if (iSp->second->qualityInfo().size())
        {
           return true;
        }
        ++iSp;
     }
     return false; // avoid compiler warning.
  }
  else
  {
     return static_cast<bool>(m_dataSetBase->spectralData()->qualityInfo().size());
  }
  return false;
  //## end DataSet::anyQuality%3F74811501CE.body
}

bool DataSet::anyGrouping () const
{
  //## begin DataSet::anyGrouping%3F74815A002B.body preserve=yes
  if (isMultiple())
  {
     SpectralDataMap::const_iterator iSp = m_dataSetBase->multiSpectralData().begin();
     SpectralDataMap::const_iterator iEnd = m_dataSetBase->multiSpectralData().end();
     while (iSp != iEnd)
     {
        if (iSp->second->groupingInfo().size())
        {
           return true;
        }
        ++iSp;
     }
  }
  else
  {
     return static_cast<bool>(m_dataSetBase->spectralData()->groupingInfo().size());
  }
  return false;
  //## end DataSet::anyGrouping%3F74815A002B.body
}

bool DataSet::aScaleIsKeyword () const
{
  //## begin DataSet::aScaleIsKeyword%3F7C76D5003C.body preserve=yes
  return m_dataSetBase->aScaleIsKeyword();
  //## end DataSet::aScaleIsKeyword%3F7C76D5003C.body
}

bool DataSet::bScaleIsKeyword () const
{
  //## begin DataSet::bScaleIsKeyword%3F7C772002E9.body preserve=yes
  return m_dataSetBase->bScaleIsKeyword();
  //## end DataSet::bScaleIsKeyword%3F7C772002E9.body
}

string DataSet::getFullPathName () const
{
  //## begin DataSet::getFullPathName%3F983B1E0388.body preserve=yes

   // DataSetBase's m_dataName stores the filename exactly as the
   // user has entered it from the data command.  So it could contain
   // a leading absolute or relative path.

   string fullPathName;   
   if (m_dataSetBase->dataName().find('/') == 0)
   {
      // We already have the absolute path.
      fullPathName = m_dataSetBase->dataName();
   }
   else
   {
      fullPathName = m_dataSetBase->runPath();

      if(*(fullPathName.rbegin()) != '/')
          fullPathName += '/';

      fullPathName += m_dataSetBase->dataName();
   }
   return fullPathName;
  //## end DataSet::getFullPathName%3F983B1E0388.body
}

void DataSet::setRunPath ()
{
  //## begin DataSet::setRunPath%3F992588017C.body preserve=yes
    m_dataSetBase->runPath(XSutility::getRunPath());
  //## end DataSet::setRunPath%3F992588017C.body
}

bool DataSet::isNet (const RealArray& spectrum)
{
  //## begin DataSet::isNet%3FD88DBD0209.body preserve=yes
  //## end DataSet::isNet%3FD88DBD0209.body

  return true;
}

const string& DataSet::getRunPath () const
{
  //## begin DataSet::getRunPath%41925EA0037D.body preserve=yes
    return m_dataSetBase->runPath();
  //## end DataSet::getRunPath%41925EA0037D.body
}

void DataSet::insertSpectrum (SpectralData* s)
{
  //## begin DataSet::insertSpectrum%41FA8E2A00B0.body preserve=yes
    if(s->rowNumber() == 0)
	dataSetBase()->spectralData(s);
    else
	dataSetBase()->multiSpectralData().insert(std::make_pair(s->rowNumber(), s));
  //## end DataSet::insertSpectrum%41FA8E2A00B0.body
}

// Additional Declarations
  //## begin DataSet%362CB3E90259.declarations preserve=yes

bool operator<(const DataSet& left, const DataSet& right)
{
        if (left.m_dataSetBase->dataName() < right.m_dataSetBase->dataName()) return true;
        else 
        {
                if (left.m_dataSetBase->dataName() == right.m_dataSetBase->dataName())
                {
                        return left.m_dataSetBase->index() < right.m_dataSetBase->index();
                }
                else return false;
        }
}

bool operator==(const DataSet& left, const DataSet& right)
{
        if (left.m_dataSetBase->dataName() != right.m_dataSetBase->dataName()) return false;
        if (left.m_dataSetBase->index() != right.m_dataSetBase->index()) return false;
        return true;
}

bool operator!=(const DataSet& left, const DataSet& right)
{
        return !operator==(left,right);
}

bool operator>(const DataSet& left, const DataSet& right)
{
        return !operator<(left,right) && operator!=(left,right);
}

  //## end DataSet%362CB3E90259.declarations
//## begin module%36894B22C6D8.epilog preserve=yes
//## end module%36894B22C6D8.epilog
